Package org.jboss.resteasy.spi

## Interface MethodInjector

- All Known Implementing Classes:
    `MethodInjectorImpl`

      public interface MethodInjector

  Will invoke a method in the context of an HTTP request. Does all the parameter injection for you.
  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `expectsBody()` |
    `ValueInjector[]` | `getParams()` |
    `Object` | `injectArguments​(HttpRequest request, HttpResponse response)` | Create the arguments that would be used to invoke the method in the context of an HTTP request.
    `Object` | `invoke​(HttpRequest request, HttpResponse response, Object target)` | Invoke on a method in the context of an HTTP request.

- - ### Method Detail

    - #### invoke

          Object invoke​(HttpRequest request,
                        HttpResponse response,
                        Object target)
                 throws Failure,
                        ApplicationException

      Invoke on a method in the context of an HTTP request. Does all JAX-RS parameter injection.
      Parameters:
        `request` - http request
        `response` - http response
        `target` - target object
      Returns:
        returned object or CompletionStage
      Throws:
        `Failure` - if application failure occurred
        `ApplicationException`

    - #### injectArguments

          Object injectArguments​(HttpRequest request,
                                 HttpResponse response)
                          throws Failure

      Create the arguments that would be used to invoke the method in the context of an HTTP request.
      Parameters:
        `request` - http request
        `response` - http response
      Returns:
        array of arguments or CompletionStage if args need to be constructed async
      Throws:
        `Failure` - if application failure occurred

    - #### getParams

          ValueInjector[] getParams()

    - #### expectsBody

          boolean expectsBody()